SystemOrganization addCategory: #'BlobFollower-Etoys'!
SystemOrganization addCategory: #'BlobFollower-Core'!

Player subclass: #BlobFollowerPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Etoys'!

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 17:15'!
getBlobFound
	^ self getValueFromCostume: #blobFound! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Tera 3/27/2014 10:45'!
getBlobHeight
	^ self getValueFromCostume: #blobHeight! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Tera 3/27/2014 10:45'!
getBlobWidth
	^ self getValueFromCostume: #blobWidth! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:56'!
getBlobX
	^ self getValueFromCostume: #blobX! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Tera 3/6/2014 14:23'!
getBlobY
	^ self getValueFromCostume: #blobY! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getBrightnessMargin
	^ self getValueFromCostume: #brightnessMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 17:33'!
getFps
	^ self getValueFromCostume: #fps! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getHueMargin
	^ self getValueFromCostume: #hueMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getSaturationMargin
	^ self getValueFromCostume: #saturationMargin! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getSource
	^ self getValueFromCostume: #source! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
getTrackedColor
	^ self getValueFromCostume: #trackedColor! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
setBrightnessMargin: value
	^ self setCostumeSlot: #brightnessMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:29'!
setHueMargin: value
	^ self setCostumeSlot: #hueMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:30'!
setSaturationMargin: value
	^ self setCostumeSlot: #saturationMargin: toValue: value! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:31'!
setSource: aPlayer
	^ self setCostumeSlot: #source: toValue: aPlayer costume renderedMorph! !

!BlobFollowerPlayer methodsFor: 'slots' stamp: 'Richo 9/18/2012 16:30'!
setTrackedColor: value
	^ self setCostumeSlot: #trackedColor: toValue: value! !

!WebCamMorph methodsFor: '*BlobFollower-Core' stamp: 'Richo 2/27/2014 09:49'!
form
	^ displayForm deepCopy! !

Object subclass: #ImageAnalyzer
	instanceVariableNames: 'source trackedColor hueMargin saturationMargin brightnessMargin last fails fps times frames lastTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Core'!

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetColumnSkip
	<cdecl: long 'getColumnSkip' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetRectangleOverlapping
	<cdecl: long 'getRectangleOverlapping' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetRowSkip
	<cdecl: long 'getRowSkip' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetColumnSkip: value
	<cdecl: void 'setColumnSkip' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:09'!
apiSetHue: min max: max
	<cdecl: void 'setHue' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetRectangleOverlapping: value
	<cdecl: void 'setRectangleOverlapping' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetRowSkip: value
	<cdecl: void 'setRowSkip' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetSat: min max: max
	<cdecl: void 'setSaturation' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetV: min max: max
	<cdecl: void 'setBrightness' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiTrackMainRectangle: aBitmap width: w height: h
	<cdecl: ImageRectangle 'trackMainRectangle' (ushort* long long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'instance creation' stamp: 'Richo 9/18/2012 15:06'!
on: aMorph track: trackedColor h: hueMargin s: saturationMargin v: brightnessMargin
	^ self basicNew
		initializeWith: aMorph
		trackedColor: trackedColor
		hueMargin: hueMargin
		saturationMargin: saturationMargin
		brightnessMargin: brightnessMargin! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:24'!
blobFound
	^ fails <= 10! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
brightnessMargin
	"Answer the value of brightnessMargin"

	^ brightnessMargin! !

!ImageAnalyzer methodsFor: 'initialize-release' stamp: 'Richo 9/18/2012 16:25'!
configure
	self class
		apiSetHue: trackedColor hue - hueMargin
		max: trackedColor hue + hueMargin;
		apiSetSat: trackedColor saturation - saturationMargin
		max: trackedColor saturation + saturationMargin;
		apiSetV: trackedColor brightness - brightnessMargin 
		max: trackedColor brightness + brightnessMargin ! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:32'!
form
	| form |
	form := true caseOf: {
		[source isKindOf: WebCamMorph]
			-> [source form].
		[source isKindOf: SketchMorph]
			-> [source rotatedForm].
		[source isKindOf: Morph]
			-> [source imageForm]
	}.
	form depth ~= 16
		ifTrue: [form := form asFormOfDepth: 16].
	^ form! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:34'!
fps
	^ fps! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
hueMargin
	"Answer the value of hueMargin"

	^ hueMargin! !

!ImageAnalyzer methodsFor: 'initialize-release' stamp: 'Richo 9/18/2012 17:37'!
initializeWith: aMorph 
trackedColor: aColor
hueMargin: hue
saturationMargin: saturation
brightnessMargin: brightness

	fails := fps := 0.
	frames := 0.
	source := aMorph.
	trackedColor := aColor.
	hueMargin := hue.
	saturationMargin := saturation.
	brightnessMargin := brightness.
	self configure;
		initialize! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
saturationMargin
	"Answer the value of saturationMargin"

	^ saturationMargin! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
source
	"Answer the value of source"

	^ source! !

!ImageAnalyzer methodsFor: 'tracking' stamp: 'Richo 9/18/2012 17:41'!
track
	| form rect |
	form := self form.
	frames >= 10
		ifTrue: [lastTime
			ifNil: [lastTime := Time millisecondClockValue]
			ifNotNil: [fps := 1000 / (Time millisecondClockValue - lastTime / 10)].
				frames := 0.
				lastTime := Time millisecondClockValue]
		ifFalse: [frames := frames + 1].
	rect := self class 
		apiTrackMainRectangle: form bits
		width: form width
		height: form height.
	(form boundingBox containsPoint: rect centerX @ rect centerY)
		ifTrue: [fails := 0.
			^ last := Rectangle
				origin: rect left @ rect top
				corner: rect right @ rect bottom]
		ifFalse: [(last isNil or: [fails > 10])
			ifTrue: [^ form boundingBox]
			ifFalse: [fails := fails + 1.
				^ last]]! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
trackedColor
	"Answer the value of trackedColor"

	^ trackedColor! !

RectangleMorph subclass: #BlobFollowerMorph
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Etoys'!

!BlobFollowerMorph class methodsFor: 'as yet unclassified' stamp: 'Tera 3/27/2014 10:52'!
additionsToViewerCategories
	^ # ((blob (
(slot source '' Player readWrite Player getSource Player setSource:)
(slot trackedColor '' Color readWrite Player getTrackedColor Player setTrackedColor:)
(slot hueMargin '' Number readWrite Player getHueMargin Player setHueMargin:)
(slot saturationMargin '' Number readWrite Player getSaturationMargin Player setSaturationMargin:)
(slot brightnessMargin '' Number readWrite Player getBrightnessMargin Player setBrightnessMargin:)
(slot blobX '' Number readOnly Player getBlobX unused unused)
(slot blobY '' Number readOnly Player getBlobY unused unused)
(slot blobWidth '' Number readOnly Player getBlobWidth unused unused)
(slot blobHeight '' Number readOnly Player getBlobHeight unused unused)
(slot blobFound '' Boolean readOnly Player getBlobFound unused unused)
(slot fps '' Number readOnly Player getFps unused unused)
)))
! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:17'!
blobFound
	^ analyzer ifNil: [false] ifNotNil: [:a | a blobFound]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Tera 3/27/2014 10:41'!
blobHeight
	^ self height / self source height! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Tera 3/27/2014 10:40'!
blobWidth
	^ self width / self source width! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 16:57'!
blobX
	^ self center x - self source left / self source width! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Tera 3/6/2014 14:26'!
blobY
	^ self source bottom - self center y / self source height! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
brightnessMargin
	^ analyzer 
		ifNil: [0.2]
		ifNotNil: [:a | a brightnessMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:46'!
brightnessMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: self hueMargin
		s: self saturationMargin
		v: aNumber! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:33'!
fps
	^ analyzer ifNil: [0] ifNotNil: [:a | a fps]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
hueMargin
	^ analyzer 
		ifNil: [20]
		ifNotNil: [:a | a hueMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
hueMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: aNumber
		s: self saturationMargin
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'initialization' stamp: 'Richo 9/18/2012 15:48'!
initialize
	super initialize.
	self color: Color transparent! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 16:25'!
newPlayerInstance
	^ BlobFollowerPlayer newUserInstance! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
saturationMargin
	^ analyzer 
		ifNil: [0.2]
		ifNotNil: [:a | a saturationMargin]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
saturationMargin: aNumber
	analyzer := ImageAnalyzer
		on: self source
		track: self trackedColor
		h: self hueMargin
		s: aNumber
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
source
	^ analyzer 
		ifNil: [World]
		ifNotNil: [:a | a source]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
source: aMorph
	analyzer := ImageAnalyzer
		on: aMorph
		track: self trackedColor
		h: self hueMargin
		s: self saturationMargin
		v: self brightnessMargin! !

!BlobFollowerMorph methodsFor: 'stepping' stamp: 'Tera 3/27/2014 10:34'!
step
	analyzer ifNil: [^ self].
	self source isInWorld ifFalse: [^ self].
	self isInWorld ifFalse: [^ self].
	self owner addMorph:self inFrontOf: self source.
	self bounds: (analyzer track translateBy: self source topLeft).
	! !

!BlobFollowerMorph methodsFor: 'stepping' stamp: 'Richo 9/18/2012 15:53'!
stepTime
	^ 1! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:47'!
trackedColor
	^ analyzer 
		ifNil: [Color blue]
		ifNotNil: [:a | a trackedColor]! !

!BlobFollowerMorph methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:45'!
trackedColor: aColor
	analyzer := ImageAnalyzer
		on: self source
		track: aColor
		h: self hueMargin
		s: self saturationMargin
		v: self brightnessMargin! !

ExternalStructure subclass: #ImageRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Core'!

!ImageRectangle class methodsFor: 'as yet unclassified' stamp: 'Richo 9/12/2012 16:16'!
fields
	"
	self defineFields.
	"
	^ #(
	(left 'long') 
	(top 'long') 
	(right 'long') 
	(bottom 'long') 
	(centerX 'long')
	(centerY 'long') )! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
bottom
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
bottom: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerX
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerX: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerY
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerY: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
left
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
left: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
right
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
right: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
top
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
top: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !
